<?php
defined('index') or header('location:http://'.$_SERVER['HTTP_HOST']);

function startup(){
	connect_to_db();
}

function connect_to_db(){
	global $db;
  $db = new Mysqlidb (dbhost, dbusername, dbpassword, dbname);
	$db->setPrefix (dbprefix);
}

function curURL() {
    $pageURL = 'http';
    if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
    $pageURL .= "://";
    if ($_SERVER["SERVER_PORT"] != "80") {
    	$pageURL .=          
    	$_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
    }else {
    	$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
    }
    $pageURL=trim($pageURL,'/');
    return $pageURL;
}

function s($variable) {
	global $db;
  $db->where ('name', $variable);
	$s = $db->getOne ('settings','value');
	return $s['value'];
}

function token() {
	$a = md5(substr(session_id(), 2, 7));
	$b = $_SERVER['HTTP_USER_AGENT'];
	$token = md5($a.$b.site);
	return $token;
}

function uri($pos){
	$uri = sanitize(parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH),'url');
	$uri = trim($uri, ' /');
	$parts = explode('/', $uri);
	return $parts[$pos];
}

function breadcrumbs(){
	$uri = sanitize(parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH),'url');
	$uri = trim($uri, ' /');
	$parts = explode('/', $uri);
	$c=count($parts)-1;
	$link=_site;
	echo '<ul>';
		echo '<li><a href="'.$link.'">Home</a></li>';
		foreach($parts as $k => $v){
			if($k<$c){
				$link.='/'.$v;
				echo '<li><a href="'.$link.'">'.$v.'</a></li>';
			}else
				echo '<li>'.buangmin(buangexthtml($v)).'</li>';
		}
	echo '</ul>';
}

function buangexthtml($text){
	$o=preg_replace('/\.html$/', '', $text);
	return $o;
}

function buangmin($text){
	$o=preg_replace('/-/', ' ', $text);
	return $o;
}

function redirect($url) {
	@header("location:".$url);
}

function getauthor($id){
	global $db;
	$db->where('id',$id);
	$post=$db->getOne('users','realname');
	return $post['realname'];
}

function gettags($id){
	global $db;
	$db->join("post_tag p","p.tag_id=t.id","INNER");
	$db->where("p.post_id",$id);
	$t=$db->get("tag t", null,"t.nama,t.seftitle");
	return $t;
}

function posts($kategori,$jumlah){
    global $db;
    $db->join("kategori k", "p.kategori=k.id", "INNER");
    $db->where('p.type', 'post');
    $db->where('k.nama', $kategori);
    $db->orderBy("p.date","Desc");
    $posts = $db->get("posts p",$jumlah,"p.*,k.sefkategori");
    return $posts;
}

function textlimit($text,$limit=100){
	$text=htmlentities(strip_tags($text));
	if(strlen($text)>$limit){
		$o = substr($text,0,$limit);
		$o = substr($text,0,strrpos($o," "));
	}else
		$o = $text;
	return $o;
}

function postpermalink($link){
	$link=_site.'/'.$link.'.html';
	return $link;
}

function postpermalinkumkm($link){
	$link=_site.'/umkm/'.$link;
	return $link;
}

function getimage($text){
	if (preg_match('/<img (.*?)>/', $text, $match)){
		preg_match('/src="(.*?)"/', $match[0], $match);
		//$o=explode('/',$match[1]);
		//$c=count($o);
		return $match[1];
	}else{
		return pathmedia.'images/noimage.jpg';
	}
}

function tanggal($tgl){
	return strftime('%d %b %Y', strtotime($tgl));
}

function testimoni($jumlah=NULL){
	global $db;
	$db->orderBy('id','Desc');
	$testimoni=$db->get('testimoni',$jumlah);
	return $testimoni;
}

function tampilkankategori(){
	global $db;
	$db->orderBy("nama","asc");
	$r = $db->get("kategori");
	return $r;
}

function tampilkantag(){
	global $db;
	$db->orderBy("nama","asc");
	$r = $db->get("tag");
	return $r;
}

function nlkebr($data){
	$newLineArray = array('\r\n','\n\r','\n','\r');
	$data = str_replace($newLineArray,'<br />',nl2br($data));
	return $data;
}

function harga($h){
	$h=number_format($h,0,'','.');
	$h='Rp. '.$h.',-';
	return $h;
}

function ukuran_file($bytes, $precision = 2) { 
    $units = array('B', 'KB', 'MB', 'GB', 'TB'); 
 
    $bytes = max($bytes, 0); 
    $pow = floor(($bytes ? log($bytes) : 0) / log(1024)); 
    $pow = min($pow, count($units) - 1); 
 
    $bytes /= pow(1024, $pow); 
 
    return round($bytes, $precision) . ' ' . $units[$pow]; 
} 

function ceklogin(){
	if(isset($_SESSION['login']) && isset($_SESSION['user']) && $_SESSION['login']===token().md5($_SESSION['user'])) return true; else return false;
}

function cekinputuserpass($input) {
	$output = trim($input);
	$output = clean(filter($output,'string'));
	if (ctype_alnum($output) === true) {
		return $output;
	} else {
		return null;
	}
}

function cekuserpass($user,$pass){
	global $db;
  $pass=sha1($pass);
  $db->where('username',$user);
	$db->where('password',md5($pass));
	$r=$db->getOne('users');
	if(count($r)>0)
		return true;
	else
		return false;
}

function getiduser($user){
  global $db;
  $db->where('username',$user);
  $r=$db->getOne('users','id');
  if(count($r)>0)
    return $r['id'];
  else
    return null;
}

function getuser($cols,$key,$val){
  global $db;
  $db->where($key,$val);
  $r=$db->getOne('users',$cols);
  if(count($r)>0)
    return $r;
  else
    return null;
}

function get_token($token) {
	$x = rand();
	unset($_SESSION[$token]);
	$_SESSION[$token]=md5($x);
	return $x;
}
function cek_token($token,$x){
  if(isset($_SESSION[$token]) and $_SESSION[$token]==md5($x))
    return true;
  else
    return false;
}

function mbstring_binary_safe_encoding( $reset = false ) {
  static $encodings = array();
  static $overloaded = null;

  if ( is_null( $overloaded ) )
    $overloaded = function_exists( 'mb_internal_encoding' ) && ( ini_get( 'mbstring.func_overload' ) & 2 );

  if ( false === $overloaded )
    return;

  if ( ! $reset ) {
    $encoding = mb_internal_encoding();
    array_push( $encodings, $encoding );
    mb_internal_encoding( 'ISO-8859-1' );
  }

  if ( $reset && $encodings ) {
    $encoding = array_pop( $encodings );
    mb_internal_encoding( $encoding );
  }
}

function reset_mbstring_encoding() {
  mbstring_binary_safe_encoding( true );
}

function seems_utf8($str) {
  mbstring_binary_safe_encoding();
  $length = strlen($str);
  reset_mbstring_encoding();
  for ($i=0; $i < $length; $i++) {
    $c = ord($str[$i]);
    if ($c < 0x80) $n = 0; # 0bbbbbbb
    elseif (($c & 0xE0) == 0xC0) $n=1; # 110bbbbb
    elseif (($c & 0xF0) == 0xE0) $n=2; # 1110bbbb
    elseif (($c & 0xF8) == 0xF0) $n=3; # 11110bbb
    elseif (($c & 0xFC) == 0xF8) $n=4; # 111110bb
    elseif (($c & 0xFE) == 0xFC) $n=5; # 1111110b
    else return false; # Does not match any model
    for ($j=0; $j<$n; $j++) { # n bytes matching 10bbbbbb follow ?
      if ((++$i == $length) || ((ord($str[$i]) & 0xC0) != 0x80))
        return false;
    }
  }
  return true;
}

function utf8_uri_encode( $utf8_string, $length = 0 ) {
  $unicode = '';
  $values = array();
  $num_octets = 1;
  $unicode_length = 0;

  mbstring_binary_safe_encoding();
  $string_length = strlen( $utf8_string );
  reset_mbstring_encoding();

  for ($i = 0; $i < $string_length; $i++ ) {

    $value = ord( $utf8_string[ $i ] );

    if ( $value < 128 ) {
      if ( $length && ( $unicode_length >= $length ) )
        break;
      $unicode .= chr($value);
      $unicode_length++;
    } else {
      if ( count( $values ) == 0 ) $num_octets = ( $value < 224 ) ? 2 : 3;

      $values[] = $value;

      if ( $length && ( $unicode_length + ($num_octets * 3) ) > $length )
        break;
      if ( count( $values ) == $num_octets ) {
        if ($num_octets == 3) {
          $unicode .= '%' . dechex($values[0]) . '%' . dechex($values[1]) . '%' . dechex($values[2]);
          $unicode_length += 9;
        } else {
          $unicode .= '%' . dechex($values[0]) . '%' . dechex($values[1]);
          $unicode_length += 6;
        }

        $values = array();
        $num_octets = 1;
      }
    }
  }

  return $unicode;
}

function sefjudul( $title, $raw_title = '', $context = 'display' ) {
  $title = strip_tags($title);
  // Preserve escaped octets.
  $title = preg_replace('|%([a-fA-F0-9][a-fA-F0-9])|', '---$1---', $title);
  // Remove percent signs that are not part of an octet.
  $title = str_replace('%', '', $title);
  // Restore octets.
  $title = preg_replace('|---([a-fA-F0-9][a-fA-F0-9])---|', '%$1', $title);

  if (seems_utf8($title)) {
    if (function_exists('mb_strtolower')) {
      $title = mb_strtolower($title, 'UTF-8');
    }
    $title = utf8_uri_encode($title, 200);
  }

  $title = strtolower($title);
  $title = preg_replace('/&.+?;/', '', $title); // kill entities
  $title = str_replace('.', '-', $title);

  if ( 'save' == $context ) {
    // Convert nbsp, ndash and mdash to hyphens
    $title = str_replace( array( '%c2%a0', '%e2%80%93', '%e2%80%94' ), '-', $title );

    // Strip these characters entirely
    $title = str_replace( array(
      // iexcl and iquest
      '%c2%a1', '%c2%bf',
      // angle quotes
      '%c2%ab', '%c2%bb', '%e2%80%b9', '%e2%80%ba',
      // curly quotes
      '%e2%80%98', '%e2%80%99', '%e2%80%9c', '%e2%80%9d',
      '%e2%80%9a', '%e2%80%9b', '%e2%80%9e', '%e2%80%9f',
      // copy, reg, deg, hellip and trade
      '%c2%a9', '%c2%ae', '%c2%b0', '%e2%80%a6', '%e2%84%a2',
      // acute accents
      '%c2%b4', '%cb%8a', '%cc%81', '%cd%81',
      // grave accent, macron, caron
      '%cc%80', '%cc%84', '%cc%8c',
    ), '', $title );

    // Convert times to x
    $title = str_replace( '%c3%97', 'x', $title );
  }

  $title = preg_replace('/[^%a-z0-9 _-]/', '', $title);
  $title = preg_replace('/\s+/', '-', $title);
  $title = preg_replace('|-+|', '-', $title);
  $title = trim($title, '-');

  return $title;
}

$customcss='';
function addcss($css){
  global $customcss,$urltema;
  $customcss .= '<link rel="stylesheet" type="text/css" href="'.$css.'" />'."\n";
}
$customjs='';
function addjs($js){
  global $customjs,$urltema;
  $customjs .= '<script type="text/javascript" src="'.$js.'"></script>'."\n";
}

function menu($group_id, $attr = '', $attrss = '') {
    global $db;
    $tree = new MenuTree;
    $db->where('group_id',$group_id);
    $db->orderBy('parent_id','asc')->orderBy('position','asc');
    $menu = $db->get('menu');
    foreach ($menu as $r => $row) {
      $label = '<a href="'.$row['url'].'">';
      if($row['parent_id']==0){
        $label .= $row['title'];
      }else
        $label .= $row['title'];
      $label .= '</a>';

      $li_attr = '';
      if ($row['class']) {
        $li_attr = ' class="'.$row['class'].'"';
      }
      $tree->add_row($row['id'], $row['parent_id'], $li_attr, $label);
    }
    $menu = $tree->generate_list($attr, $attrss);
    return $menu;
  }

function view($data=null,$func=null,$header=true,$footer=true){
  if($header) include_once pathtema.'header.php';
  is_null($func) ? call_user_func('utama',$data) : call_user_func($func,$data);
  if($footer) include_once pathtema.'footer.php';
}
function upload_image($file,$nama){
  $exts = array('jpeg', 'jpg', 'png');
  $types = array('image/jpeg', 'image/jpg', 'image/png');
  $type = $file['type'];
  $ext = strtolower(end(explode('.', $file['name'])));
  if (in_array($ext, $exts) && in_array($type, $types)) {
    $name = str_replace('.', '', strtolower($nama));
    $name = str_replace(' ', '-', strtolower($name)).'.'.$ext;
    move_uploaded_file($file['tmp_name'], path.'media/images/' . $name);
  }
  return $name;
}
function save_data($tabel,$data){
  global $db;
  $db->insert($tabel, $data);
  return $db;
}
function delete_data($tabel,$key,$val){
  global $db;
  $db->where($key,$val);
  $db->delete($tabel);
  return $db;
}
function update_data($tabel,$data,$key,$val){
  global $db;
  $db->where($key,$val);
  $db->update($tabel,$data);
  return $db;
}
function captchaupload() {
  $x = rand();
  unset($_SESSION['captchaupload']);
  $_SESSION['captchaupload']=md5($x);
  return $x;
}
?>