<?php
defined('index') or header('location:http://'.$_SERVER['HTTP_HOST']);
$page_title='Menu Manager';
addcss(site.aset.'menumanager/css/style.css');
addjs(site.aset.'menumanager/js/jquery-1.7.2.min.js');
addjs(site.aset.'menumanager/js/iutil.js');
addjs(site.aset.'menumanager/js/idrag.js');
addjs(site.aset.'menumanager/js/idrop.js');
addjs(site.aset.'menumanager/js/isortables.js');
addjs(site.aset.'menumanager/js/inestedsortable.js');
addjs(site.aset.'menumanager/js/menu.js');

function get_label($row) {
	$label =
		'<div class="ns-row">' .
		'<div class="ns-title">'.$row['title'].'</div>' .
		'<div class="ns-description">'.$row['description'].'</div>' .
		'<div class="ns-url">'.$row['url'].'</div>' .
		'<div class="ns-class">'.$row['class'].'</div>' .
		'<div class="ns-actions">' .
			'<a href="#" class="edit-menu" title="Edit Menu">' .
				'<img src="'.site.aset.'menumanager/images/edit.png" alt="Edit">' .
			'</a>' .
			'<a href="#" class="delete-menu">' .
				'<img src="'.site.aset.'menumanager/images/cross.png" alt="Delete">' .
			'</a>' .
			'<input type="hidden" name="menu_id" value="'.$row['id'].'">' .
		'</div>' .
		'</div>';
	return $label;
}

function get_menu($group_id) {
	global $db;
	$db->where('group_id',$group_id);
	$db->orderBy('parent_id','asc')->orderBy('position','asc');
	return $db->get('menu');
}

function get_menu_groups() {
	global $db;
	$db->orderBy('id','asc');
	return $db->get('menu_group');
}

function get_menu_group_title($group_id) {
	global $db;
	$db->where('id',$group_id);
	$r=$db->getOne('menu_group','title');
	return $r['title'];
}

function save_position() {
	if (isset($_POST['easymm'])) {
		$easymm = $_POST['easymm'];
		update_position(0, $easymm);
	}
}

function update_position($parent, $children) {
	global $db;
	$i = 1;
	foreach ($children as $k => $v) {
		$id = (int)$v['id'];
		$data = Array ("parent_id" => $parent, "position" => $i);
    	$db->where('id', $id);
    	$db->update('menu',$data);
		if (isset($children[$k]['children'][0])) {
			update_position($id, $children[$k]['children']);
		}
		$i++;
	}
}

function get_last_position($group_id) {
	global $db;
	$db->where('group_id',$group_id);
	$r=$db->getOne('menu','MAX(position)');
    return $r['MAX(position)'];
}

function add() {
	global $db;
		if (isset($_POST['title'])) {
			$data['title'] = trim($_POST['title']);
			if (!empty($data['title'])) {
				$data['description'] = $_POST['description'];
				$data['url'] = $_POST['url'];
				$data['class'] = $_POST['class'];
				$data['group_id'] = $_POST['group_id'];
				$data['position'] = get_last_position($_POST['group_id']) + 1;
				if ($id=$db->insert('menu', $data)) {
					$data['id'] = $id;
					$response['status'] = 1;
					$li_id = 'menu-'.$data['id'];
					$response['li'] = '<li id="'.$li_id.'" class="sortable">'.get_label($data).'</li>';
					$response['li_id'] = $li_id;
				} else {
					$response['status'] = 2;
					$response['msg'] = 'Add menu error.';
				}
			} else {
				$response['status'] = 3;
			}
			header('Content-type: application/json');
			echo json_encode($response);
		}
	}

function get_row($id) {
	global $db;
	$db->where('id',$id);
	return $db->getOne('menu');
}

function edit()
	{
		if (isset($_GET['id'])) {
			$id = (int)$_GET['id'];
			$data = get_row($id);
			?>
			<h2>Edit Menu</h2>
			<form method="post" action="menumanager/save_menu">
				<p>
					<label for="edit-menu-title">Title</label>
					<input type="text" name="title" id="edit-menu-title" value="<?php echo $data['title']; ?>">
				</p>
				<p>
					<label for="edit-menu-description">Description</label>
					<input type="text" name="description" id="edit-menu-description" value="<?php echo $data['description']; ?>">
				</p>
				<p>
					<label for="edit-menu-url">URL</label>
					<input type="text" name="url" id="edit-menu-url" value="<?php echo $data['url']; ?>">
				</p>
				<p>
					<label for="edit-menu-class">Class</label>
					<input type="text" name="class" id="edit-menu-class" value="<?php echo $data['class']; ?>">
				</p>
				<input type="hidden" name="menu_id" value="<?php echo $data['id']; ?>">
			</form>
			<?php
		}
	}

function get_descendants($id)
	{
		global $db;
		$db->where('parent_id',$id);
		$r=$db->get('menu',null,'id');
		if ($db->count > 0) {
			foreach ($r as $res) {
				$db->where('id', $res['id']);
				$db->delete('menu');
				get_descendants($res['id']);
			}
		}
	}

function delete() {
	global $db;
		if (isset($_POST['id'])) {
			$id = (int)$_POST['id'];
			$response['success'] = false;
			$db->where('id', $id);
			if($db->delete('menu')) $response['success'] = true; else $response['success'] = false;
			get_descendants($id);
			header('Content-type: application/json');
			echo json_encode($response);
		}
	}

function save()
	{
		global $db;
		if (isset($_POST['title'])) {
			$data = array(
				'title' => trim($_POST['title']),
				'description' => $_POST['description'],
				'url' => $_POST['url'],
				'class' => $_POST['class']
				);
			if (!empty($data['title'])) {
				$db->where('id', $_POST['menu_id']);
				if ($db->update('menu',$data)) {
					$response['status'] = 1;
					$d['title'] = $data['title'];
					$d['description'] = $data['description'];
					$d['url'] = $data['url'];
					$d['klass'] = $data['class'];
					$response['menu'] = $d;
				} else {
					$response['status'] = 2;
					$response['msg'] = 'Edit menu error.';
				}
			} else {
				$response['status'] = 3;
			}
			header('Content-type: application/json');
			echo json_encode($response);
		}
	}

function add_group(){
	echo
	'<h2>Add Menu Group</h2>'.
	'<form method="post" action="menumanager/add_group">'.
	'<p>'.
		'<label for="menu-group-title">Group Title</label>'.
		'<input type="text" name="title" id="menu-group-title">'.
	'</p>'.
	'</form>';
}

function save_group() {
	global $db;
		if (isset($_POST['title'])) {
			$data['title'] = trim($_POST['title']);
			if (!empty($data['title'])) {
				if ($id=$db->insert('menu_group', $data)) {
					$response['id'] = $id;
					$response['status'] = 1;					
				} else {
					$response['status'] = 2;
					$response['msg'] = 'Add menu group error.';
				}
			} else {
				$response['status'] = 3;
			}
			header('Content-type: application/json');
			echo json_encode($response);
		}
	}

function edit_group() {
	global $db;
	if (isset($_POST['title'])) {
		$id = (int)$_POST['id'];
		$data = array ('title' => trim($_POST['title']));
		$response['success'] = false;
		$db->where('id', $id);
		if ($db->update('menu_group', $data)) {
			$response['success'] = true;
		}
		header('Content-type: application/json');
		echo json_encode($response);
	}
}

function delete_group() {
	global $db;
		if (isset($_POST['id'])) {
			$id = (int)$_POST['id'];
			if ($id == 1) {
				$response['success'] = false;
				$response['msg'] = 'Cannot delete Group ID = 1';
			} else {
				$db->where('id', $id);
				if ($db->delete('menu_group')) {
					$db->where('group_id', $id);
					$db->delete('menu');
					$response['success'] = true;
				} else {
					$response['success'] = false;
				}
			}
			header('Content-type: application/json');
			echo json_encode($response);
		}
	}
?>